︠fe78d49b-7a29-42bb-8164-13286ca684ads︠
def Dragon(n):
    """
    This function returns the nth element of the dragon sequence
    """
    if n == 0:
        return 0
    else:
        while Mod(n, 2) == 0:
        #while n%2 == 0:
            n = n / 2
    return ((n-1)/2)%2

def Dragon2(n):
    """
    This function returns the 2nth element of the dragon sequence
    """
    return Dragon(2*n)

def Pagoda(n):
    """
    This function returns the nth element of the pagoda sequence
    """
    return Dragon(n+1) - Dragon(n-1)

def GoldenSection(n):
    """
    This function returns the nth element of the golden section sequence
    It gol_{2n} = 0 and gol_{2n+1} = (-1)^{n+1} * catalan_number(n)
    """
    if n%2==0:
        return 0
    else:
        return catalan_number((n-1)/2)*(1 - (n-1)%4)

def plot_labels(x_ticks,x_labels,y_ticks,y_labels,fontsize=12):
    import matplotlib.ticker
    def latex_ticklabels(lbls_x,lbls_y):
        return [matplotlib.ticker.FixedFormatter(lbls_x),matplotlib.ticker.FixedFormatter(lbls_y)]
    ft=fontsize
    return plot([],ticks=[x_ticks,y_ticks],tick_formatter=latex_ticklabels(x_labels,y_labels),fontsize=ft)

def fibonaci_poly(n,k,char=0):
    """
    This function returns the vector of coefficients of the
    kth coefficient of the nth fibonacci polynomial of degree n
    F(n,k) modulo char, which is set to be 0 by default.
    Fibonacci polynomials are defined recursively by
    q_n(t) = t*q_{n-1}(t) + q_{n-2}(t)
    and we use the formula F(n,k)=binomial((n+k-1)/2,k)
    """
    if Mod(n,2)==Mod(k,2):
        return 0
    else:
        return Mod(binomial((n+k-1)/2,k),char)
︡d1880b0f-2cfc-44ce-b243-fdda473931e4︡{"done":true}
︠aa48feb5-c53a-4a1e-8bde-7ecc0ac83ff8︠
print([Mod(catalan_number(n),2) for n in range (1,300)])
print([Mod(catalan_number(n),3) for n in range (1,300)])
︡8d88520e-13f8-46d7-bb68-d7ee9f408f1d︡{"stdout":"[1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]\n"}︡{"stdout":"[1, 2, 2, 2, 0, 0, 0, 2, 2, 2, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 2, 1, 1, 1, 0, 0, 0, 1, 1, 1, 2, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 2, 1, 1, 1, 0, 0, 0, 1, 1, 1, 2, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 2, 2, 2, 0, 0, 0, 2, 2, 2, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 2, 1, 1, 1, 0, 0, 0, 1, 1, 1, 2, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 2, 2, 2, 0, 0, 0, 2, 2, 2, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]\n"}︡{"done":true}︡
︠63840bf0-266c-4b8c-9e3d-110b2ceb85fds︠
import time
start = time.time()

M = 170
leng = 2*M
char = 3
pag = [Mod(Pagoda(n),char) for n in range (1,leng)]
#rpf = [Dragon(n) for n in range (1,leng)]
#gol = [Mod(GoldenSection(n),char) for n in range (1,leng)]
par = [Mod(Pagoda(-n),char) for n in range (1,leng)]

table = [[0 for j in range(0,m+1)] for m in range(1,M+1)]
for m in range(1,M+1):
    tempMat = [[0 for j in range(0,m)] for n in range(0,m)]
    for h in range(0,m+1):
        for j in range(0,h):
            #print(j,h,m,"here")
            #tempMat[j] = [rpf[j + n] for n in range(0,m)]
            tempMat[j] = [pag[j + n] for n in range(0,m)]
        for j in range(h,m):
            #print(j,h,m,"there")
            tempMat[j] = [par[j - h - 1 + n] for n in range(0,m)]
        table[m-1][h] = Mod(matrix(tempMat).det(),char)

end = time.time()
print(end - start)
P=plot_labels([],[],[],[])
for c in range(0,char):
    rgb=(char-1-c%char)/(char-1)
    P=P+points([(1+j,-m) for m in range(0,M) for j in range(0,m+1) if table[m][j]==mod(c,char)],color=Color(rgb,rgb,rgb),marker='s')

P.axes_color('white')
P.show()

end = time.time()
print(end - start)
︡1a7ebfa8-6f02-4618-a2f7-4b8c9af9d35a︡{"stderr":"Error in lines 9-16\n"}︡{"stderr":"Traceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1191, in execute\n    flags=compile_flags), namespace, locals)\n  File \"\", line 7, in <module>\n  File \"src/cysignals/signals.pyx\", line 320, in cysignals.signals.python_check_interrupt\nKeyboardInterrupt\n"}︡{"done":true}
︠5c7393d8-6902-460a-9139-c3a3a253a3a3s︠
import time
start = time.time()

M = 200
leng = 2*M
char = 3
pag = [Mod(Pagoda(n),char) for n in range (1,leng)]
#rpf = [Dragon(n) for n in range (1,leng)]
#gol = [Mod(GoldenSection(n),char) for n in range (1,leng)]
cat = [Mod(catalan_number(n),char) for n in range (1,leng)]

table = [[0 for j in range(0,m+1)] for m in range(1,M+1)]
for m in range(1,M+1):
    tempMat = [[0 for j in range(0,m)] for n in range(0,m)]
    for h in range(0,m+1):
        for j in range(0,h):
            #print(j,h,m,"here")
            #tempMat[j] = [rpf[j + n] for n in range(0,m)]
            tempMat[j] = [pag[j + n] for n in range(0,m)]
        for j in range(h,m):
            #print(j,h,m,"there")
            tempMat[j] = [cat[j - h + n] for n in range(0,m)]
        table[m-1][h] = Mod(matrix(tempMat).det(),char)

end = time.time()
print(end - start)

#calculate defficiencies
defs = [[0 for j in range(0,m+1)] for m in range(1,M+1)]
for m in range (M,0,-1): #start counting from the bottom
    for j in range (0,m+1):
        if table[m-1][j] != 0:
            defs[m-1][j] = 0
        else:
            if m == M:
                defs[m-1][j] = 1
            else:
                defs[m-1][j] = max(defs[m][j],defs[m][j+1]) + 1

print([max(defs[m-1]) for m in range(1,M+1)])

P=plot_labels([],[],[],[])
for c in range(0,char):
    rgb=(char-1-c%char)/(char-1)
    P=P+points([(1+j,-m) for m in range(1,M+1) for j in range(0,m+1) if table[m-1][j]==mod(c,char)],color=Color(rgb,rgb,rgb),marker='s')

P.axes_color('white')
P.show()

end = time.time()
print(end - start)
︡e73282e2-de3f-4884-b62a-19d04272aa7a︡{"stdout":"1145.0585959\n"}︡{"stdout":"[1, 0, 4, 3, 2, 1, 1, 1, 7, 6, 5, 4, 3, 2, 4, 3, 2, 7, 9, 8, 7, 6, 5, 4, 4, 4, 5, 4, 3, 2, 3, 13, 12, 11, 10, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 10, 9, 8, 7, 6, 5, 9, 8, 7, 11, 10, 9, 8, 7, 6, 8, 7, 6, 5, 5, 4, 5, 8, 9, 16, 15, 14, 13, 12, 11, 10, 9, 8, 10, 9, 8, 7, 6, 5, 4, 4, 4, 3, 10, 9, 8, 7, 6, 5, 6, 12, 11, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 7, 6, 7, 6, 7, 10, 9, 8, 12, 11, 10, 9, 8, 9, 8, 22, 21, 20, 26, 25, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 13, 12, 11, 14, 13, 12, 11, 10, 9, 8, 7, 26, 25, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 12, 11, 10, 9, 10, 9, 8, 9, 8, 7, 6, 5, 12, 11, 12, 11, 10, 9, 11, 10, 9, 8, 7, 6, 9, 8, 7, 6, 5, 4, 3, 2, 1]\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-2317d2a7-6976-4548-a618-2869c2de6c7d/140/tmp__LZmVi.svg","show":true,"text":null,"uuid":"6e310361-a84f-4d85-82c5-c32719990dd1"},"once":false}︡{"stdout":"1150.42876387\n"}︡{"done":true}︡
︠3d45a246-f5e5-436e-aeb7-2f5ab8d78b00s︠
import time
start = time.time()

M = 600
leng = 2*M
char = 3
weight = 1/2

pag = [Mod(Pagoda(n),char) for n in range (1,leng)]
#rpf = [Dragon(n) for n in range (1,leng)]
#gol = [Mod(GoldenSection(n),char) for n in range (1,leng)]
cat = [Mod(catalan_number(n),char) for n in range (1,leng)]

end = time.time()
print(end - start)

dets = [0 for m in range(1,M+1)]
for m in range(1,M+1):
    tempMat = [[0 for j in range(0,m)] for n in range(0,m)]
    h = round(weight*m)
    for j in range(0,h):
        tempMat[j] = [pag[j + n] for n in range(0,m)]
    for j in range(h,m):
        tempMat[j] = [cat[j - h + n] for n in range(0,m)]
    dets[m-1] = Mod(matrix(tempMat).det(),char)

print(dets)

defs = [0 for m in range(1,M+1)]
for m in range (M,0,-1): #start counting from the bottom
    if dets[m-1] != 0:
        defs[m-1] = 0
    else:
        if m == M:
            defs[m-1] = 1
        else:
            defs[m-1] = defs[m] + 1

print(defs)
print(max(defs))

end = time.time()
print(end - start)
︡2ad54b95-8672-4cec-baf8-9e7e7401549e︡{"stdout":"0.205230951309\n"}︡{"stdout":"[0, 2, 0, 0, 0, 0, 1, 0, 2, 2, 0, 0, 0, 2, 2, 0, 2, 0, 2, 2, 0, 0, 2, 2, 2, 0, 0, 1, 2, 1, 1, 2, 1, 1, 2, 1, 1, 0, 0, 2, 1, 1, 0, 2, 2, 0, 0, 2, 0, 2, 1, 1, 2, 0, 0, 1, 0, 1, 2, 2, 2, 2, 0, 2, 0, 1, 1, 2, 2, 1, 0, 2, 0, 0, 0, 1, 1, 1, 0, 1, 0, 2, 2, 0, 0, 1, 1, 2, 0, 2, 1, 2, 1, 1, 2, 1, 0, 2, 0, 0, 0, 0, 1, 0, 0, 2, 2, 0, 2, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 2, 2, 0, 0, 0, 2, 2, 2, 0, 0, 1, 0, 1, 0, 2, 2, 2, 2, 1, 0, 0, 1, 2, 0, 2, 0, 0, 1, 2, 2, 2, 1, 2, 0, 1, 2, 2, 1, 0, 1, 1, 2, 1, 0, 0, 0, 1, 2, 0, 1, 0, 1, 2, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 1, 2, 2, 2, 0, 2, 2, 2, 0, 0, 1, 2, 1, 2, 1, 1, 2, 2, 0, 0, 1, 2, 0, 0, 0, 0, 1, 2, 0, 2, 2, 2, 2, 2, 1, 1, 2, 1, 1, 1, 1, 2, 0, 0, 1, 2, 1, 1, 1, 0, 0, 1, 2, 0, 1, 0, 0, 1, 2, 1, 0, 0, 1, 2, 1, 2, 1, 0, 2, 2, 2, 2, 1, 1, 0, 2, 0, 1, 0, 0, 1, 2, 2, 1, 0, 0, 2, 1, 0, 1, 2, 1, 0, 0, 0, 1, 0, 2, 2, 2, 0, 0, 0, 0, 0, 0, 2, 2, 2, 0, 2, 2, 2, 0, 0, 1, 1, 1, 0, 0, 2, 2, 0, 2, 1, 2, 2, 2, 0, 0, 0, 0, 2, 2, 2, 2, 2, 2, 2, 1, 2, 1, 0, 0, 2, 0, 0, 0, 2, 1, 1, 2, 1, 2, 0, 1, 1, 0, 1, 0, 0, 0, 0, 1, 2, 2, 1, 1, 0, 1, 2, 2, 1, 2, 2, 1, 0, 1, 1, 1, 2, 2, 2, 1, 0, 0, 1, 1, 0, 0, 2, 1, 1, 2, 0, 2, 1, 0, 0, 2, 1, 0, 0, 2, 1, 1, 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 2, 0, 0, 1, 2, 1, 0, 0, 0, 0, 2, 2, 1, 2, 2, 2, 1, 2, 1, 1, 1, 0, 0, 2, 2, 1, 0, 1, 2, 1, 2, 0, 1, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 0, 0, 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 0, 1, 2, 1, 1, 2, 2, 1, 1, 0, 0, 2, 0, 0, 0, 2, 0, 1, 0, 1, 2, 2, 2, 2, 1, 0, 0, 0, 1, 2, 2, 2, 2, 1, 0, 2, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 2, 1, 2, 1, 0, 0, 0, 1, 0, 0, 0, 2, 1, 2, 2, 2, 2, 2, 1, 0, 1, 0, 2, 2, 0, 1, 1, 2, 2, 2, 2, 1, 0, 2, 1, 1, 1, 0, 0, 0, 1, 1, 2, 2, 2, 1, 2, 2, 1, 1, 2, 2, 1, 0, 2, 2, 1, 0, 0, 0, 0, 0, 2, 1, 0, 1, 2, 0, 0, 0, 2, 1, 1, 0, 1, 1, 2, 0, 0, 0, 0, 0, 1, 1, 0, 0, 2, 2, 2, 2, 0]\n"}︡{"stdout":"[1, 0, 4, 3, 2, 1, 0, 1, 0, 0, 3, 2, 1, 0, 0, 1, 0, 1, 0, 0, 2, 1, 0, 0, 0, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 0, 1, 0, 0, 2, 1, 0, 1, 0, 0, 0, 0, 2, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 3, 2, 1, 0, 0, 0, 1, 0, 1, 0, 0, 2, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 4, 3, 2, 1, 0, 2, 1, 0, 0, 1, 0, 1, 0, 6, 5, 4, 3, 2, 1, 0, 0, 0, 0, 3, 2, 1, 0, 0, 0, 2, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 2, 1, 0, 0, 1, 0, 2, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 3, 2, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 4, 3, 2, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 0, 2, 1, 0, 0, 1, 0, 2, 1, 0, 0, 0, 2, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 2, 1, 0, 0, 0, 0, 2, 1, 0, 0, 1, 0, 0, 0, 3, 2, 1, 0, 1, 0, 0, 0, 6, 5, 4, 3, 2, 1, 0, 0, 0, 1, 0, 0, 0, 2, 1, 0, 0, 0, 2, 1, 0, 0, 1, 0, 0, 0, 0, 0, 4, 3, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 3, 2, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 4, 3, 2, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 2, 1, 0, 0, 0, 0, 1, 0, 0, 2, 1, 0, 0, 2, 1, 0, 0, 0, 3, 2, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 0, 4, 3, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 0, 8, 7, 6, 5, 4, 3, 2, 1, 0, 0, 3, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 3, 2, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 3, 2, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 6, 5, 4, 3, 2, 1, 0, 2, 1, 0, 0, 0, 0, 3, 2, 1, 0, 3, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 3, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 5, 4, 3, 2, 1, 0, 0, 1, 0, 0, 3, 2, 1, 0, 0, 0, 1, 0, 0, 0, 5, 4, 3, 2, 1, 0, 0, 2, 1, 0, 0, 0, 0, 1]\n"}︡{"stdout":"8\n"}︡{"stdout":"654.19997406\n"}︡{"done":true}︡
︠1a38231d-ed23-4341-b043-684c2860f977︠

m)]
            tempMat[j] = [pag[j + n] for n in range(0,m)]
        for j in range(h,m):
            #print(j,h,m,"there")
            tempMat[j] = [cat[j - h + n] for n in range(0,m)]
        table[m-1][h] = Mod(matrix(tempMat).det(),char)

end = time.time()
print(end - start)

#calculate defficiencies
defs = [[0 for j in range(0,m+1)] for m in range(1,M+1)]
for m in range (M,0,-1): #start counting from the bottom
    for j in range (0,m+1):
        if table[m-1][j] != 0:
            defs[m-1][j] = 0
        else:
            if m == M:
                defs[m-1][j] = 1
            else:
                defs[m-1][j] = max(defs[m][j],defs[m][j+1]) + 1

print([max(defs[m-1]) for m in range(1,M+1)])

P=plot_labels([],[],[],[])
for c in range(0,char):
    rgb=(char-1-c%char)/(char-1)
    P=P+points([(1+j,-m) for m in range(1,M+1) for j in range(0,m+1) if table[m-1][j]==mod(c,char)],color=Color(rgb,rgb,rgb),marker='s')

P.axes_color('white')
P.show()

end = time.time()
print(end - start)
︡de6d4782-43ac-4259-af52-b9b9ece2f1d2︡{"stdout":"1145.0585959\n"}︡{"stdout":"[1, 0, 4, 3, 2, 1, 1, 1, 7, 6, 5, 4, 3, 2, 4, 3, 2, 7, 9, 8, 7, 6, 5, 4, 4, 4, 5, 4, 3, 2, 3, 13, 12, 11, 10, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 10, 9, 8, 7, 6, 5, 9, 8, 7, 11, 10, 9, 8, 7, 6, 8, 7, 6, 5, 5, 4, 5, 8, 9, 16, 15, 14, 13, 12, 11, 10, 9, 8, 10, 9, 8, 7, 6, 5, 4, 4, 4, 3, 10, 9, 8, 7, 6, 5, 6, 12, 11, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 7, 6, 7, 6, 7, 10, 9, 8, 12, 11, 10, 9, 8, 9, 8, 22, 21, 20, 26, 25, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 13, 12, 11, 14, 13, 12, 11, 10, 9, 8, 7, 26, 25, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 12, 11, 10, 9, 10, 9, 8, 9, 8, 7, 6, 5, 12, 11, 12, 11, 10, 9, 11, 10, 9, 8, 7, 6, 9, 8, 7, 6, 5, 4, 3, 2, 1]\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-2317d2a7-6976-4548-a618-2869c2de6c7d/140/tmp__LZmVi.svg","show":true,"text":null,"uuid":"6e310361-a84f-4d85-82c5-c32719990dd1"},"once":false}︡{"stdout":"1150.42876387\n"}︡{"done":true}︡
︠5fea90a5-f607-4581-9a3d-de7a5b28d41bs︠
import time
start = time.time()

M = 600
leng = 2*M
char = 3
pag = [Mod(Pagoda(n),char) for n in range (1,leng)]
#rpf = [Dragon(n) for n in range (1,leng)]
#gol = [Mod(GoldenSection(n),char) for n in range (1,leng)]
cat = [Mod(catalan_number(n),char) for n in range (1,leng)]

end = time.time()
print(end - start)

dets = [0 for m in range(1,M+1)]
for m in range(1,M+1):
    tempMat = [[0 for j in range(0,m)] for n in range(0,m)]
    h = round(weight*m)
    for j in range(0,h):
        tempMat[j] = [pag[j + n] for n in range(0,m)]
    for j in range(h,m):
        tempMat[j] = [cat[j - h + n] for n in range(0,m)]
    dets[m-1] = Mod(matrix(tempMat).det(),char)

print(dets)

defs = [0 for m in range(1,M+1)]
for m in range (M,0,-1): #start counting from the bottom
    if dets[m-1] != 0:
        defs[m-1] = 0
    else:
        if m == M:
            defs[m-1] = 1
        else:
            defs[m-1] = defs[m] + 1

print(defs)
print(max(defs))

end = time.time()
print(end - start)
︡0fc61d9a-05e8-4f8d-97ea-62a768bc034d︡{"stdout":"0.205230951309\n"}︡{"stdout":"[0, 2, 0, 0, 0, 0, 1, 0, 2, 2, 0, 0, 0, 2, 2, 0, 2, 0, 2, 2, 0, 0, 2, 2, 2, 0, 0, 1, 2, 1, 1, 2, 1, 1, 2, 1, 1, 0, 0, 2, 1, 1, 0, 2, 2, 0, 0, 2, 0, 2, 1, 1, 2, 0, 0, 1, 0, 1, 2, 2, 2, 2, 0, 2, 0, 1, 1, 2, 2, 1, 0, 2, 0, 0, 0, 1, 1, 1, 0, 1, 0, 2, 2, 0, 0, 1, 1, 2, 0, 2, 1, 2, 1, 1, 2, 1, 0, 2, 0, 0, 0, 0, 1, 0, 0, 2, 2, 0, 2, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 2, 2, 0, 0, 0, 2, 2, 2, 0, 0, 1, 0, 1, 0, 2, 2, 2, 2, 1, 0, 0, 1, 2, 0, 2, 0, 0, 1, 2, 2, 2, 1, 2, 0, 1, 2, 2, 1, 0, 1, 1, 2, 1, 0, 0, 0, 1, 2, 0, 1, 0, 1, 2, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 1, 2, 2, 2, 0, 2, 2, 2, 0, 0, 1, 2, 1, 2, 1, 1, 2, 2, 0, 0, 1, 2, 0, 0, 0, 0, 1, 2, 0, 2, 2, 2, 2, 2, 1, 1, 2, 1, 1, 1, 1, 2, 0, 0, 1, 2, 1, 1, 1, 0, 0, 1, 2, 0, 1, 0, 0, 1, 2, 1, 0, 0, 1, 2, 1, 2, 1, 0, 2, 2, 2, 2, 1, 1, 0, 2, 0, 1, 0, 0, 1, 2, 2, 1, 0, 0, 2, 1, 0, 1, 2, 1, 0, 0, 0, 1, 0, 2, 2, 2, 0, 0, 0, 0, 0, 0, 2, 2, 2, 0, 2, 2, 2, 0, 0, 1, 1, 1, 0, 0, 2, 2, 0, 2, 1, 2, 2, 2, 0, 0, 0, 0, 2, 2, 2, 2, 2, 2, 2, 1, 2, 1, 0, 0, 2, 0, 0, 0, 2, 1, 1, 2, 1, 2, 0, 1, 1, 0, 1, 0, 0, 0, 0, 1, 2, 2, 1, 1, 0, 1, 2, 2, 1, 2, 2, 1, 0, 1, 1, 1, 2, 2, 2, 1, 0, 0, 1, 1, 0, 0, 2, 1, 1, 2, 0, 2, 1, 0, 0, 2, 1, 0, 0, 2, 1, 1, 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 2, 0, 0, 1, 2, 1, 0, 0, 0, 0, 2, 2, 1, 2, 2, 2, 1, 2, 1, 1, 1, 0, 0, 2, 2, 1, 0, 1, 2, 1, 2, 0, 1, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 0, 0, 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 0, 1, 2, 1, 1, 2, 2, 1, 1, 0, 0, 2, 0, 0, 0, 2, 0, 1, 0, 1, 2, 2, 2, 2, 1, 0, 0, 0, 1, 2, 2, 2, 2, 1, 0, 2, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 2, 1, 2, 1, 0, 0, 0, 1, 0, 0, 0, 2, 1, 2, 2, 2, 2, 2, 1, 0, 1, 0, 2, 2, 0, 1, 1, 2, 2, 2, 2, 1, 0, 2, 1, 1, 1, 0, 0, 0, 1, 1, 2, 2, 2, 1, 2, 2, 1, 1, 2, 2, 1, 0, 2, 2, 1, 0, 0, 0, 0, 0, 2, 1, 0, 1, 2, 0, 0, 0, 2, 1, 1, 0, 1, 1, 2, 0, 0, 0, 0, 0, 1, 1, 0, 0, 2, 2, 2, 2, 0]\n"}︡{"stdout":"[1, 0, 4, 3, 2, 1, 0, 1, 0, 0, 3, 2, 1, 0, 0, 1, 0, 1, 0, 0, 2, 1, 0, 0, 0, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 0, 1, 0, 0, 2, 1, 0, 1, 0, 0, 0, 0, 2, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 3, 2, 1, 0, 0, 0, 1, 0, 1, 0, 0, 2, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 4, 3, 2, 1, 0, 2, 1, 0, 0, 1, 0, 1, 0, 6, 5, 4, 3, 2, 1, 0, 0, 0, 0, 3, 2, 1, 0, 0, 0, 2, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 2, 1, 0, 0, 1, 0, 2, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 3, 2, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 4, 3, 2, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 0, 2, 1, 0, 0, 1, 0, 2, 1, 0, 0, 0, 2, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 2, 1, 0, 0, 0, 0, 2, 1, 0, 0, 1, 0, 0, 0, 3, 2, 1, 0, 1, 0, 0, 0, 6, 5, 4, 3, 2, 1, 0, 0, 0, 1, 0, 0, 0, 2, 1, 0, 0, 0, 2, 1, 0, 0, 1, 0, 0, 0, 0, 0, 4, 3, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 3, 2, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 4, 3, 2, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 2, 1, 0, 0, 0, 0, 1, 0, 0, 2, 1, 0, 0, 2, 1, 0, 0, 0, 3, 2, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 0, 4, 3, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 0, 8, 7, 6, 5, 4, 3, 2, 1, 0, 0, 3, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 0, 3, 2, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 3, 2, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 6, 5, 4, 3, 2, 1, 0, 2, 1, 0, 0, 0, 0, 3, 2, 1, 0, 3, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 3, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 5, 4, 3, 2, 1, 0, 0, 1, 0, 0, 3, 2, 1, 0, 0, 0, 1, 0, 0, 0, 5, 4, 3, 2, 1, 0, 0, 2, 1, 0, 0, 0, 0, 1]\n"}︡{"stdout":"8\n"}︡{"stdout":"654.19997406\n"}︡{"done":true}︡
︠3272ecf3-7b9b-41c8-87b8-8f8ab77295a1s︠
import time
start = time.time()

M = 1000
leng = 2*M
char = 3

pag = [Pagoda(n) for n in range (1,leng)]
pag_def = 1

defs_along_convergents = [0 for m in range(1,M+1)]
for m in range(1,M+1):
    i=0
    fib_m = [fibonaci_poly(m,n,char) for n in range(0,m)]
    while i < m + pag_def and sum([pag[i + n]*fib_m[n] for n in range(0,m)])%char==0:
        i += 1
    defs_along_convergents[m-1] = i

print(defs_along_convergents)
print(max(defs_along_convergents))

end = time.time()
print(end - start)
︡bf3413d7-6a64-42a9-a221-8196f6d3f6fc︡{"stdout":"[1, 0, 2, 0, 0, 3, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 3, 0, 0, 2, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 0, 2, 0, 0, 1, 0, 0, 2, 0, 1, 3, 1, 0, 0, 0, 1, 7, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 4, 0, 0, 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 4, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 2, 0, 0, 3, 0, 0, 0, 0, 0, 1, 1, 0, 4, 0, 1, 5, 1, 0, 2, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 3, 1, 0, 6, 0, 1, 3, 1, 0, 0, 0, 1, 1, 0, 0, 2, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 2, 0, 0, 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 3, 0, 0, 4, 0, 0, 1, 1, 0, 0, 0, 0, 3, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 2, 0, 0, 1, 1, 0, 0, 0, 1, 3, 1, 0, 4, 0, 1, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 3, 1, 0, 0, 0, 0, 3, 0, 0, 2, 0, 0, 3, 0, 0, 0, 0, 0, 1, 1, 0, 4, 0, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 0, 0, 2, 0, 0, 1, 0, 0, 2, 0, 0, 3, 0, 0, 0, 0, 0, 1, 1, 0, 2, 0, 0, 3, 0, 0, 0, 0, 1, 1, 0, 0, 6, 0, 0, 1, 1, 0, 0, 0, 0, 3, 0, 0, 2, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 2, 0, 0, 1, 1, 0, 2, 0, 0, 3, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 0, 6, 0, 1, 1, 0, 0, 2, 0, 0, 7, 0, 0, 2, 0, 0, 1, 0, 0, 2, 0, 1, 1, 0, 0, 0, 0, 1, 3, 1, 0, 2, 0, 0, 5, 0, 0, 2, 0, 0, 1, 0, 0, 2, 0, 0, 1, 0, 0, 0, 0, 0, 3, 0, 0, 2, 0, 1, 1, 0, 0, 2, 0, 1, 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 2, 0, 0, 1, 0, 0, 0, 0, 0, 3, 0, 0, 2, 0, 0, 1, 1, 0, 0, 0, 1, 3, 1, 0, 0, 0, 0, 1, 0, 0, 2, 0, 0, 3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 3, 1, 0, 2, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 2, 0, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1, 0, 0, 6, 0, 0, 1, 0, 0, 2, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 2, 0, 1, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 7, 1, 0, 0, 0, 0, 1, 1, 0, 2, 0, 0, 1, 1, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1, 0, 0, 6, 0, 0, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 3, 0, 0, 2, 0, 0, 1, 0, 0, 0, 0, 1, 3, 1, 0, 0, 0, 0, 3, 0, 0, 2, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 5, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 2, 0, 1, 1, 0, 0, 2, 0, 1, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 0, 6, 0, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 6, 0, 0, 1, 0, 0, 4, 0, 0, 1, 1, 0, 2, 0, 0, 1, 0, 0, 4, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 3, 1, 0, 0, 0, 0, 11, 0, 0, 0, 0, 1, 3, 1, 0, 0, 0, 1, 1, 0, 0, 2, 0]\n"}︡{"stdout":"11\n"}︡{"stdout":"25.9435641766\n"}︡{"done":true}︡
︠1504b85e-9846-41bf-9ec9-68f6f0636c04s︠
import time
start = time.time()

M = 100
leng = 2*M
char = 3
rpf = [Mod(Dragon(n),char) for n in range (1,leng)]
rpf2 = [Mod(Dragon(2*n-1),char) for n in range (1,leng)]
table = [[0 for j in range(0,m+1)] for m in range(1,M+1)]
for m in range(1,M+1):
    tempMat = [[0 for j in range(0,m)] for n in range(0,m)]
    for h in range(0,m+1):
        for j in range(0,h):
            #print(j,h,m,"here")
            #tempMat[j] = [rpf[j + n] for n in range(0,m)]
            tempMat[j] = [rpf[j + n] for n in range(0,m)]
        for j in range(h,m):
            #print(j,h,m,"there")
            tempMat[j] = [rpf2[j - h - 1 + n] for n in range(0,m)]
        table[m-1][h] = Mod(matrix(tempMat).det(),char)

end = time.time()
print(end - start)
P=plot_labels([],[],[],[])
for c in range(0,char):
    rgb=(char-1-c%char)/(char-1)
    P=P+points([(1+j,-m) for m in range(0,M) for j in range(0,m+1) if table[m][j]==mod(c,char)],color=Color(rgb,rgb,rgb),marker='s')

P.axes_color('white')
P.show()

end = time.time()
print(end - start)
︡0fd74d50-749f-4196-b2aa-0b0924db1a70︡{"stdout":"67.6483972073\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-2317d2a7-6976-4548-a618-2869c2de6c7d/318/tmp_h9yaHj.svg","show":true,"text":null,"uuid":"641e196c-e05f-40a3-ab4b-444c3525fc8a"},"once":false}︡{"stdout":"69.0173401833\n"}︡{"done":true}
︠c1671282-47fc-4d2c-a160-64c266d0fac2s︠


rpf2 = [Mod(Dragon(2*n),char) for n in range (1,leng)]
print(rpf2)
︡9d643df4-22c5-414f-b5e8-d7fbf4cd8a38︡{"stdout":"[0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 1, 0, 0, 1, 1]\n"}︡{"done":true}
︠df3c38ca-5c98-4777-9e00-476d5d03cd8b︠









